Bug 1875939 - vsphere - cloning a Windows 2019 (1909) template fails with Invalid operation for device '0'.
Summary: vsphere - cloning a Windows 2019 (1909) template fails with Invalid operation...
Keywords:
Status: ON_QA
Alias: None
Product: OpenShift Container Platform
Classification: Red Hat
Component: Cloud Compute
Version: 4.6
Hardware: Unspecified
OS: Unspecified
unspecified
medium
Target Milestone: ---
: 4.6.0
Assignee: Danil Grigorev
QA Contact: Milind Yadav
URL:
Whiteboard:
Depends On:
Blocks:
TreeView+ depends on / blocked
 
Reported: 2020-09-04 16:41 UTC by Joseph Callen
Modified: 2020-09-14 02:04 UTC (History)
4 users (show)

Fixed In Version:
Doc Type: If docs needed, set a value
Doc Text:
Clone Of:
Environment:
Last Closed:
Target Upstream Version:


Attachments (Terms of Use)


Links
System ID Priority Status Summary Last Updated
Github openshift machine-api-operator pull 699 None closed Bug 1875939: vsphere - cloning a Windows 2019 (1909) template fails with Invalid operation for device '0'. 2020-09-15 06:02:25 UTC

Description Joseph Callen 2020-09-04 16:41:16 UTC
Description of problem:

When creating a machineset for a windows guest in vSphere the Windows template fails to clone with 
"Failed to clone 1909-template on 10.2.32.6, WorkloadDatastore in SDDC-Datacenter to windows-worker-skss8 on 10.2.32.9, WorkloadDatastore in jcallen-test-mxcwh in SDDC-Datacenter: Invalid operation for device '0'."

This has to do with the deviceChange:
https://github.com/openshift/machine-api-operator/blob/master/pkg/controller/vsphere/reconciler.go#L582

I am guessing but I think the process of removing and creating network interfaces contributes to this error. It could also be the disk change but since that is a minor change I don't think its the cause.


Version-Release number of selected component (if applicable):


How reproducible:


Steps to Reproduce:
1.
2.
3.

Actual results:


Expected results:


Additional info:

Comment 1 Joseph Callen 2020-09-04 16:43:19 UTC
I have a branch that I have been using to test and modify to support a customization spec. I confirmed with that branch that deviceChange does cause the "invalid operation for device '0'.
See:
https://github.com/openshift/machine-api-operator/compare/master...jcpowermac:vsphere_windows_customization

Please reach out for additional context.

Comment 2 Joseph Callen 2020-09-04 16:44:28 UTC
Also tried to remove the cd-rom from the template but that didn't work. I have seen that cause issues in cloning processes previously.

Comment 3 Aravindh Puthiyaparambil 2020-09-04 17:24:34 UTC
@mimccune this needed for Windows Container to GA in the 4.6 timeframe.

Comment 4 Michael McCune 2020-09-04 18:18:59 UTC
thanks for the update Aravindh, i wasn't sure =)

Comment 5 Danil Grigorev 2020-09-10 23:18:23 UTC
The issue appears when a user requires to clone a disk from the template (probably snapshot as well) and specifies a lesser size than the one set on the template. This requires a specific `shrink` operation on the volume in advance. The fix would include the check for the template disk size before requesting "edit" operation on it's size.


Note You need to log in before you can comment on or make changes to this bug.